/*
 * Copyright (C) 2025  Tim Zimmermann <tim@aglais.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.aglais.zms.log4j2;

import org.aglais.zms.util.Log;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

/**
 * Logging implementation using Log4J2.
 */
public class Log4J2Log extends Log {

    private static final String LOG_TAG = Log4J2Log.class.getSimpleName();

    @Override
    protected void logImpl(int level, String tag, String msg, Throwable tr) {
        Logger logger = LogManager.getLogger(tag);

        switch (level) {
            case VERBOSE:
                logger.trace(msg, tr);
                break;
            case DEBUG:
                logger.debug(msg, tr);
                break;
            case INFO:
                logger.info(msg, tr);
                break;
            case WARN:
                logger.warn(msg, tr);
                break;
            case ERROR:
                logger.error(msg, tr);
                break;
            case ASSERT:
                logger.fatal(msg, tr);
                break;
            default:
                logImpl(ASSERT, LOG_TAG, "Tried to log unknown level: " + level, null);
                break;
        }
    }

}
